#ifndef _DCF_INCLUDED_
#define _DCF_INCLUDED_

#pragma used+

#include <bcd.h> 
#include <lcd.h>
#include <stdio.h>
//#include <stdlib.h>          


unsigned int zaehler_1=0;         // Diese Variable wird fr den Sekunden-Takt bentigt
unsigned int zaehler_2=0;         // Diese Variable wird fr die Erkennung vom Minutenwechsel bentigt

unsigned char uhrwerk_sekunde;    // |-- Diese Variablen sind fr die Interne Uhr, diese
unsigned char uhrwerk_minute;     // |   Uhr luft auch weiter wenn kein DCF-Signal
unsigned char uhrwerk_stunde;     // |   vorhanden ist.

unsigned char kalender_tag;       // |-- Diese Variablen sind fr den Internen Kalender.
unsigned char kalender_wochentag; // |
unsigned char kalender_monat;     // |
unsigned char kaledner_jahr;      // |

unsigned int vergangenes_dcf[3];  // Array fr die DCF-Erkennung
unsigned char zaehler_letztes_dcf;// Speichert den Empfang vom letzten DCF-Synkronisation

unsigned int faktor=1;            // Diese Variable bentigt man um die Uhr nach einer
				  // gewissen Zeit >> faktor*korrektur << wieder richtig
				  // zu stellen. Die Variable muss ebenfalls, wie
				  // dcf.fehler_zaehler ein "Int" sein, sonst funktioniert
				  // die multiplikaton nicht richtig.

bit sperre;                    	  // Diese Variable ist fr die zeitliche Korrektur
                                  



struct signal { // Struktur fr das DCF-Signal
unsigned char sekunde;
unsigned char minute;
unsigned char stunde;
unsigned char tag;
unsigned char wochentag;
unsigned char monat;
unsigned char jahr;
unsigned char synkro;             // 0=Kein Synk gefunden; 1=Synk in arbeit; 2=DCF-Betrieb
unsigned int  fehler_zaehler;     // liegt keine Synkronisation vor, wird dieser Zhler
}dcf;                             // jede Minute erhht. Ich habe "Int" gewhlt damit
                                  // der Zhler auch mal ber 255 Minuten laufen kann.
                                

#define KEINSYNK 0    	          // Es liegt kein aktuelles DCF-Signal vor
#define INARBEIT 1    	          // Es wird gerade ein DCF-Signal eingelesen
#define INSYNK 2      	          // Die Uhr luft nach dem DCF-Signal

#define KORREKTUR 97	          // Dieser Wert gibt an, nach wieviel Miuten 
                                  // die Uhr um 1 Sekunde korregiert werden muss.
                                  // Man klemmt die Antenne von der synkronisierten
                                  // Uhr ab und schaut wie hoch >dcf.fehlerzaehler< ist,
                                  // wenn die Uhr genau 1 Sekunde vor geht. Dieser Wert
                                  // ergibt dann die KORREKTUR! 

// NACHTRAG: Ich habe mit der Korrektur von 97 den Prozessor jetzt 3395 Minute ohne
//           Antenne laufen lassen ( ca. 57 Stunden ). Doch die Uhr lief immer 
//           noch Sekunde genau. ( optischen vergleich mit einer anderen Funkuhr )
//           Das msste eigentlich reichen. Interessant wre es zu wissen,
//           ob das immer noch so bleibt, wenn das Programm um einiges lnger wird.
//           Eigentlich msste es ja bleiben da die Uhr ber Interrupt gesteuert wird.


/*********************************************************************/
/* Mit dieser Funktion werden die Sonderzeichen in das LCD geladen.  */
/* Es gibt drei Arten von Antennen auf dem Display:                  */
/* "antenne_0" zeigt an, dass es kein gltiges DCF-Signal gibt       */
/* "antenne_1" zeigt an, dass das DCF-Signal gerade eingelesn wird   */
/* "antenne_2" zeigt an, dass die Uhrzeit nach dem DCF-Signal luft  */

sonderzeichen_laden()
{  
 unsigned char i;             // Laufvariable fr die for-Schleifen

// Es folgen die einzelne Sonderzeichen    

 unsigned char antenne_0[]={0x04,0x0e,0x15,0x04,0x0e,0x15,0x04,0x04};
 unsigned char antenne_1[]={0x04,0x1f,0x04,0x1f,0x04,0x04,0x04,0x04};
 unsigned char antenne_2[]={0x15,0x0e,0x04,0x15,0x0e,0x04,0x04,0x04};


// Schleifen zum schreiben der Sonderzeichen

 for (i=0; i<=8; i++)
   {          //      |-- RAM-Adresse des ersten freiprogrammierbare Zeichens
    lcd_write_byte((0x40+i), *((antenne_0)+i));
   } 
   
 for (i=0; i<=8; i++)
   {          //      |-- RAM-Adresse des zweiten freiprogrammierbare Zeichens
    lcd_write_byte((0x48+i), *((antenne_1)+i));
   } 
     
 for (i=0; i<=8; i++)
   {          //      |-- RAM-Adresse des dritten freiprogrammierbare Zeichens
    lcd_write_byte((0x50+i), *((antenne_2)+i));
   }   
   
}
/*                                                                   */
/*********************************************************************/



/*********************************************************************/
/* Diese Funktion berprft, ob die Prfbit's zu dem                 */
/* empfangenem Wert passt. Dabei muss das empfangene Prf-bit die    */
/* Anzahl der Einsen im empfangenem Byte auf eine gerade Zahl        */
/* ergnzen                                                          */

unsigned char checkPBit (unsigned char data,unsigned char pb)
  {
   unsigned char t=1,i=0,p=0;
 
   for (i=0;i<8;i++)
    {
     if((data&t)==t)
     if(p==0) p=1; else p=0;
     t<<=1;
    }
    
   if (pb==p) return 0; // Prfbit stimmt - 0 als OK Antworten
   else return 1;       // oder das Bit stimmt nicht
  }
/*                                                                   */  
/*********************************************************************/




/*********************************************************************/
/* Diese Funktion erzeugt zwei Arten von Uhren. Die erste Uhr ist    */
/* die normale DCF-Uhr. Zustzlich gibt es noch die interne Uhr      */
/* die weiterluft wenn es kein DCF-Signal gibt.                     */
/* Es werden auch die "Kontroll-Pary-Bits" ausgewertet.              */

//    |-- Es soll eine Variable an das
//    |   Hauptprogramm bergeben werden.
//    |   Es habdelt sich um die Variable
//    |   "Uhrwerk_sekunde"                        |-- bekommt aus dem Hauptprogramm den
//    |                                            |   Wert der am Port D, Pin 2, ber einer
//    |                                            |   Variable, anliegt
//    |                                            | 
unsigned char dcf_uhr_einlesen(unsigned char *antennen_signal)
{
 static unsigned char impuls=3;// Fr die Erkennung der Impuslnge des Signale 
 
 zaehler_1++;                  // Soll so lange erhht werden, bis eine Sekunde vorbei ist
 
 zaehler_2++;                  // Soll so lange erhht werden, bis mehr als eine Sekunde
                               // vorbei ist um den Minutenwechsel zwischen 58. und 0.
                               // Sekunde (etwa 1,8 Sekunden kein Signal) zu erkennen.
 /*
 Hier ist darauf zu achten dass "zaehler_1" nicht zu hoch gesetzt werden
 darf, da "zaehler_1" ja im Interrupt wieder zurck gesetzt wird. Hat
 "zaehler_1" jedoch einen zu hohen Wert, wird das "Uhrwerk" nicht mehr
 abgearbeitet. Beim Aufbau mit 4MHz ist der maximale Wert 15622.
 Bei 15623 wird das Uhrwerk nicht mehr abgearbeitet. Als Sicherheit
 senke ich den Wert noch mal um 3 auf 15620.
 
 Das Problem, die Uhr luft mit "15620" zu schnell! Nach der vorgegebenen
 Korrekturzeit in Minuten (siehe define KORREKTUR) wir die Uhr dann um
 1 Sekunde zurck gestellt.
 */      
 
 if(zaehler_1>=15620) 
  {
   uhrwerk_sekunde++;          // es ist eine Sekunde vorbei, also um eins erhhen
   zaehler_1=0;                // Sekundenzhler wieder auf 0
   
  }
                       
///////////////////////////////////////////////////////////////////////
/***** Ab hier wird das Uhrwerk erzeugt ******************************/
  
 if(uhrwerk_sekunde==60)       // Wenn 60 Sekunden vorbei sind...
  {
   uhrwerk_sekunde=0;          // Sekunden wieder auf 0 und
   uhrwerk_minute++;           // die Minuten um ein erhhen
  
   
   dcf.fehler_zaehler++;       // ist dafr gedacht, wenn man die Antenne
   if (dcf.fehler_zaehler>=2)  // direkt am Port abzieht. Wenn kein Interrupt
    {                          // mehr ausgelst wird, dann kann auch der
     dcf.synkro=KEINSYNK;      // Synk-Status nicht mehr gendert werden.
    } 
   
  }
 
 if(uhrwerk_minute==60)        // Wenn 60 Minuten vorbei sind...
  {
   uhrwerk_minute=0;           // Minuten wieder auf 0
   uhrwerk_stunde++;           // die Stunden um eins erhhen
  }
  
 
 if(uhrwerk_stunde==24)        // Wenn 24 Stunden vorbei sind... 
  {
   uhrwerk_stunde=0;           // Stunden wieder auf 0
   kalender_tag++;             // den Tag um eins erhhet
   kalender_wochentag++;       // den Wochentag um eins erhht
  }
 
 /*
 das Problem beim erhhen vom Tag ist, dass das ganze ja nur bis zum 31. funktioniert.
 Doch jetzt auch noch die Auswertung zu machen welchen Monat wir haben, ob
 28, 30 oder 31 Tage erschien mir jetzt nicht wichtig zu sein da ich "HOFFE :o)" das die
 Uhr nicht genau dann ohne >synk< bleibt!! Programmiertechnisch drfe das ja kein Problem
 sein.
 */
 
 if(kalender_wochentag == 7)   // ist der Wochentag bei 7 muss wieder
  {                            // bei 0 angefangen werde.
   kalender_wochentag = 0;
  } 
  
 /*
 Die interne Uhr luft zu schnell. Luft die Uhr nach der "Korrektur-Zeit" in Minuten,
 ohne Synkronisation, dann soll die Uhr um eine Sekunde zurckgestellt werden.
 Das ganze passier in der 3. Sekunde. 
 */ 
                             
 if((uhrwerk_sekunde == 2) && (dcf.fehler_zaehler == (faktor*KORREKTUR)))
  {
   sperre = 0; // eine Sekunde bevor die Uhr Korrigiert werden soll,
  }            // wird die Sperre wieder aufgehoben
  
  //                                              |-- hat der >dcf.fehler_zaehler< ein
  //                                              |   vielfaches von Korrektur, dann soll
  //                                              |   die Uhrzeit zurck gestellt werden
  //                                              |
 if((uhrwerk_sekunde == 3) && (sperre == 0) && (dcf.fehler_zaehler == (faktor*KORREKTUR)))
  {
   uhrwerk_sekunde-=1;         // Uhrzeit um eine Sekunde "erniedrigen"
   sperre=1;                   // Sperre aktivieren, da sonst eine "Endlosschleife" entsteht
   faktor++;                   // Faktor fr die Korrektur erhhen
  }

// Ende des Uhrwerks


// DCF Uhr dekodieren

     //   |-- ist die Variable die aus dem Hauptprogramm bergeben wird.
     //   |   die Variabler hat immer den Wert vom Port D, Pin 2. (Antennensignal)
     //   |
 if(antennen_signal)  	       
  {                            // 2500 * 64s = 160ms
   if(zaehler_2<2500) impuls=0;// Liegt ein Signal krzer als 0,1 Sekunden an, ist da einen logisch 0
   if(zaehler_2>2500) impuls=1;// liegt es lnger wie 0,1 Sekunden an, ist es einen logische 1
  }
 
 else           	       // DCF Signal fertig zum dekodieren
   {		
    if(impuls!=3 && dcf.synkro!=KEINSYNK && zaehler_2>1200)
     {
			       // Wenn Val <3 ist, und die Uhr noch nicht mit
       	        	       // dem DCF-Signal Synkronisiert ist, und kein
       	        	       // Flattern festgestellt (zaehler_2<1200) wurde

//----------- Zeit vom DCF-Signal einlesen ----------------------------
   
    if(dcf.sekunde==5)         // Die Variablen werden sicherheitshalber mit 0
     {                         // initialisiert, da die Variablen ja geschoben werden
                         
      dcf.minute=0;            // Minute initialisiern fr Neuempfang
      dcf.stunde=0;            // Stunde initialisiern fr Neuempfang
      dcf.tag=0;               // Tag initialisiern fr Neuempfang
      dcf.wochentag=0;         // Wochentag initialisiern fr Neuempfang
      dcf.monat=0;             // Monat initialisiern fr Neuempfang
      dcf.jahr=0;              // Jahr initialisiern fr Neuempfang
  
     }
          
// Die Minuten-Einer werden zwischen den 21 - 24 Sekunde,
// die Minuten Zehner zwischen den 25 - 28 Sekuden gesendet
// Zustzlich wird das Pary-Bit zum prfen noch mit eingelesen

    if(dcf.sekunde>=22 && dcf.sekunde<=28)
     {
      dcf.minute>>=1;          // es werden alle bits um eins nach rechts geschoben
      
      dcf.minute|=impuls*64;   // Das Momentane Bit (0,1 oder 0,2 Sekunden)
                               // wird an die 6. Stelle von rechts in die
                               // Variable geschoben (2^6 = 64)
                               // | 128 | 64 | 32 | 16 | 8 | 4 | 2 | 1 |
     }                         // |  7. | 6. | 5. | 4. | 3.| 2.| 1.| 0.|

// Jetzt stehen die Minuten im BCD-Formal in der Variable und mssen dann
// umgewandelt werden. Das passiert aber nur wenn die Zeit mit dem 
// "Pary" Bit geprft wurde.

    if(dcf.sekunde==29)
     {
      if(checkPBit(dcf.minute,impuls)==0)// Prfe ob das Pary-Bit zum Wert passt
       { 
        dcf.minute=bcd2bin(dcf.minute);	 // Minute umrechnen
       }
      else
        {
         dcf.synkro=KEINSYNK;            // Fehler festgestellt
        }
     }


// Die Stunden-Einer werden zwischen den 29 - 32 Sekunde,
// die Stunden Zehner zwischen den 33 - 34 Sekuden gesendet
// Zustzlich wird das Pary-Bit noch mit eingelesen
 
    if(dcf.sekunde>=30 && dcf.sekunde<=35)
     {
      dcf.stunde>>=1;	       // Bit schieben
      dcf.stunde|=impuls*64;   // Bits von oben hinzufgen
     }
 
    if(dcf.sekunde==36)
     {
      dcf.stunde>>=1;          // zustzlich ein Bit schieben, da die Stunde nur 6 Bit lang
    		               // ist. Die Funktion >bcd2bin< wrde sonst nicht funktionieren

      if(checkPBit(dcf.stunde,impuls)==0)// Prfe ob das Pary-Bit zum Wert passt
       {           
        dcf.stunde=bcd2bin(dcf.stunde);  // Stunde umrechnen
       }
      
      else
       {
        dcf.synkro=KEINSYNK;   // Fehler festgestellt
       }
     }


// Die Tages-Einer werden zwischen den 36 - 39 Sekunde,
// die Tages Zehner zwischen den 40 - 41 Sekuden gesendet
 
    if(dcf.sekunde>=37 && dcf.sekunde<=42)
     {
      dcf.tag>>=1;	       // Bit schieben
      dcf.tag|=impuls*64;      // Bits von oben hinzufgen
     }
 
    if(dcf.sekunde==42)
     {
      dcf.tag>>=1;            
      
      dcf.tag=bcd2bin(dcf.tag);// Tag umrechnen
     }
 

// Der Wochentag wird zwischen den 42 - 44 Sekunde gesendet
  
    if(dcf.sekunde>=43 && dcf.sekunde<=45)
     {
      dcf.wochentag>>=1;       // Bit schieben
      dcf.wochentag|=impuls*4; // Bits von oben hinzufgen
     }
 
    if(dcf.sekunde==45)
     {
      dcf.wochentag=bcd2bin(dcf.wochentag); // Wochentag umrechnen
     }
 
// Die Monat-Einer werden zwischen den 45 - 48 Sekunde,
// der Monat Zehner wird in der 49. Sekuden gesendet
 
    if(dcf.sekunde>=46 && dcf.sekunde<=49)
     {
      dcf.monat>>=1;	       // Bit schieben
      dcf.monat|=impuls*8;     // Bits von oben hinzufgen
     }
 
    if(dcf.sekunde==50)
     {
      dcf.monat=bcd2bin(dcf.monat);     // Monat umrechnen
     }

// Die Jahres-Einer werden zwischen den 50 - 53 Sekunde,
// die Jahres Zehner zwischen den 54 - 57 Sekuden gesendet

    if(dcf.sekunde>=51 && dcf.sekunde<=57)
     {
      dcf.jahr>>=1;	       // Bit schieben
      dcf.jahr|=impuls*128;    // Bits von oben hinzufgen
     }                         
 
    if(dcf.sekunde==58)
     {
      dcf.jahr>>=1;
      dcf.jahr=bcd2bin(dcf.jahr);       // Jahr umrechnen
     }
 
 impuls=3;		       // Wert wurde verarbeitet
 }
}
 
// Ende der DCF-Signal dekodierung

return uhrwerk_sekunde;        // rckgabe des Wertes an das Hauptprogramm
}

/*                                                                   */  
/*********************************************************************/



/*********************************************************************/
/* Diese Funktion wird von Interrupt aus dem Hauptprogramm           */
/* aufgerufen. Es wird geprft ob die interne Uhr mit dem            */
/* DCF-Signal in Synkronisation steht.                               */

dcf_interrupt_aufruf()

{


// Ist der "zaehler_2" grer wie 28000 (ca 1,8 sekunden) dann liegt ein
// Minutenwechsel vor. 
 
 if(zaehler_2>28000)
  { // Anfang Minutenwechsel erkannt
   
 
   dcf.fehler_zaehler = 0;     // zur Erkennung ob die Antenne noch am Port angeschlossen ist
   dcf.sekunde=0; 	       // damit beim Minutenwechsel die Sekunden wieder bei 0 anfngt
   if(dcf.synkro < INARBEIT)  
   {
    dcf.synkro=INARBEIT;       // Es wurde ein Minutenwechsel erkannt, also nderung des Synk-Status
    zaehler_letztes_dcf=3;     // Freigabe zum Dekodieren der DCF Zeit
   }
   
   else
      {
       // Zeit bernehmen, falls keine Fehler entstanden sind
       // Fehler wird mit Minute und Stunde =0 deklariert
       
       if(dcf.minute>60 || dcf.stunde>24)
        {
    	 dcf.synkro=KEINSYNK;		// Fehler erkannt zurck in No-Synk Modus
    	 dcf.minute=dcf.stunde=0;	// setzt die dcf.Uhrzeit beim Minutenwechsel zurck 
    	}
     
       
   else  // ist jedoch "dcf.synkro >= INARBEIT"
     { 
      uhrwerk_sekunde=0;
      vergangenes_dcf[--zaehler_letztes_dcf]=(int)dcf.stunde*100+dcf.minute;
     }

/*
Hier wird das Uhrwerk >nach< dem ersten abgleich (siehe unten), >dauernd< abgeglichen. Die Uhr
wrde durch die Synkronisation und dem Uhrwerk zwar noch ausreichen genau weiter laufen, nur
der Abgleich vom (Tag) und Monat wrde um 00:00 Uhr nicht bernommen werden.
(siehe Erklrung oben beim Uhrwerk)
*/     
     if(dcf.synkro==INSYNK)
     {
      uhrwerk_stunde=dcf.stunde;
      uhrwerk_minute=dcf.minute;
      uhrwerk_sekunde=dcf.sekunde;
          
      kalender_tag=dcf.tag;
      kalender_wochentag=dcf.wochentag;
      kalender_monat=dcf.monat;
      kaledner_jahr=dcf.jahr;
     }
     
     if(zaehler_letztes_dcf==0)
      { 
/*      
 Wenn drei Werte gelesen worden sind, muss berprft werden, ob diese in Reihe liegen.
 Wenn diese in Reihe liegen dann war die "decodierung" des DCF-Signals Erfolgreich. Jetzt wird
 das DCF-Signal >einmalig< an das >Uhrwerk< und an den >Kalender< bergeben. Auch das Antennenzeichen
 wird jetzt aktualiesiert. Dieser Abgleich passiert aber nur einmal, dann wird der Abgleich der
 Uhr nur noch im >Dauerabgleich< korriegiert (siehe oben).
*/      
    	if (vergangenes_dcf[0]-1==vergangenes_dcf[1] && vergangenes_dcf[1]-1==vergangenes_dcf[2])
    	 {
    	  uhrwerk_stunde=dcf.stunde;
          uhrwerk_minute=dcf.minute;
          uhrwerk_sekunde=dcf.sekunde;
          
          kalender_tag=dcf.tag;
          kalender_wochentag=dcf.wochentag;
          kalender_monat=dcf.monat;
          kaledner_jahr=dcf.jahr;
         }
    	
    	dcf.synkro=INSYNK;     // Uhr ist Fehlerfrei in Synk
    	zaehler_letztes_dcf=3;
      }
           
     zaehler_1=0;              // zhler fr Minutenberlauf wieder 0
    
        
    }
  
  }// Ende Minutenwechsel erkannt
 

// Ist der "zaehler_2" jedoch nur grer wie 10000 (=ca 0,6 Sekunden) dann liegt kein
// Minutenwechsel vor, sonder nur ein normaler Sekundenwechsel.
 
 if(zaehler_2>10000)
  { 
   zaehler_2=0;
   dcf.sekunde++;
  }


}
/*                                                                   */  
/*********************************************************************/



/*********************************************************************/
/* Diese Funktion erzeugt das Uhrzeit- und Datum- String.            */

dcf_uhrzeit_anzeigen()
{
 unsigned char zeit[9];		// Variable fr das Zeit-String
 unsigned char datum[10];       // Variable fr das Datum-String


//***** Aufbau des Uhr- Strings
  
//// vielleicht die Null bei kleiner zehn weg!!!!
   
    if(uhrwerk_sekunde&1) // fr das blinken der ':' auf dem Display 
     {
      sprintf(zeit,"%02u:%02u:%02u",uhrwerk_stunde,uhrwerk_minute,uhrwerk_sekunde);
     }
		 
    else
      {
       sprintf(zeit,"%02u %02u %02u",uhrwerk_stunde,uhrwerk_minute,uhrwerk_sekunde);
      }
     
//***** Aufbau des Datums- Strings
     
// Wochentag
     if(kalender_wochentag == 0) sprintf(datum,"So ");
     if(kalender_wochentag == 1) sprintf(datum,"Mo ");
     if(kalender_wochentag == 2) sprintf(datum,"Di ");
     if(kalender_wochentag == 3) sprintf(datum,"Mi ");
     if(kalender_wochentag == 4) sprintf(datum,"Do ");
     if(kalender_wochentag == 5) sprintf(datum,"Fr ");
     if(kalender_wochentag == 6) sprintf(datum,"Sa ");

// Tag 
     // Wenn der Tag kleiner wie 10 ist, dann braucht man nur die "einer"
     // Stelle auf dem Display. Sonst wrde die Zahl mit eine 0 anfangen!
     
     if(kalender_tag <10)sprintf((datum+3)," %01u.",kalender_tag);
     if(kalender_tag >=10)sprintf((datum+3),"%02u.",kalender_tag);
     
// Monat     
     if(kalender_monat == 1)  sprintf((datum+6),"Jan");
     if(kalender_monat == 2)  sprintf((datum+6),"Feb");
     if(kalender_monat == 3)
      {
       sprintf((datum+6),"M");
       sprintf((datum+7),"%1c",225); // die 225 ist das '' Zeichen
       sprintf((datum+8),"r");
      } 
     if(kalender_monat == 4)  sprintf((datum+6),"Apr");
     if(kalender_monat == 5)  sprintf((datum+6),"Mai");
     if(kalender_monat == 6)  sprintf((datum+6),"Jun");
     if(kalender_monat == 7)  sprintf((datum+6),"Jul");
     if(kalender_monat == 8)  sprintf((datum+6),"Aug");
     if(kalender_monat == 9)  sprintf((datum+6),"Sep");
     if(kalender_monat == 10) sprintf((datum+6),"Okt");
     if(kalender_monat == 11) sprintf((datum+6),"Nov");
     if(kalender_monat == 12) sprintf((datum+6),"Dez"); 
   

/*    
Es folgt die Ausgabe des Antennezeichens, dem Zeit- und Datum- Strings.
Bei den "unteren"  Werten bentigt man ein 20-Zeilen Display. So passt
alles in eine Zeile.
Die Antenne mit ihren drei verschiedenen Arten wird auf dem 
Display gefolgt von der Uhrzeit und schlieslich vom Datum. 
*/

    switch (dcf.synkro)
	{    
	 	
	 case INSYNK:       
	   lcd_gotoxy(0,0);    // Falls die Uhr mit dem DCF- Signal bereinstimmt...
           lcd_putchar(2);     // ausgabe der "antenne_2"
	   faktor=1;           // Faktor fr die Zeitkorrekur wieder auf 1
	   break;
		    
	 case INARBEIT:
	   lcd_gotoxy(0,0);    // Falls die Uhr noch nicht mit dem DCF- Signal bereinstimmt...
           lcd_putchar(1);     // ausgabe der "antenne_1"
	   break;
		    
	 case KEINSYNK:
	   lcd_gotoxy(0,0);    // Falls die Uhr kein DCF- Signal gefunden hat...
           lcd_putchar(0);     // ausgabe der "antenne_0"
	   break;
	}

   	
// Ausgabe des Uhr-Strings
   
   lcd_gotoxy(2,0);
   lcd_puts(zeit);

// Ausgabe des Datum-Strings

   lcd_gotoxy(11,0);
   lcd_puts(datum);
  
   // Ende der sekundenweisen Ausgabe   
}
/*                                                                   */  
/*********************************************************************/

#pragma used-

#endif